{{
main.spin

}}
CON
  _clkmode           = xtal1 + pll16x                   'External high-speed crystal                       
  _xinfreq           = 5_000_000                        '5MHz x 16 = 80MHz                     
          
  CLK_FREQ           = ((_clkmode-pll16x)>>6)*_xinfreq  'calculates the number of clock ticks
  MS_001             = CLK_FREQ / 1_000                 'per millisecond based on the initial settings                               
  MS_00x             = 5_000
                                                            
  inv_high           = 0                                'define the inverted High state    
  inv_low            = 1                                'define the inverted Low state
  high               = 1                                'High state                        
  low                = 0                                'Low state
                                                     
  waitPeriod         = 5_000_000                        'about 1/2 sec switch cycle     
                                                         
  video_pin          = 0                                'video trigger in    
  motor_pin          = 1                                'trigger to motor out                
  laser_pin          = 2                                'laser trigger in       
  pal_pin            = 3                                'high out if detecting PAL video
  play_FW_pin        = 5                                'play in, count up on loopback
  play_RW_pin        = 4                                'rewind in, count down on loopback
  halfspeed_pin      = 6                                'high in if desired halfspeed
  feeding_speed_pin  = 7                                'high in if desired feeding speed
  loopback_pin       = 8                                'loopack trigger in  
  missing_pin        = 9                                'missing laser bad in
  stobe_pin          = 10                               'strobe trigger out
  ntsc_pin           = 11                               'high out if detecting NTSC video               
  '                  = 12                               'base pin for TV out debugging     
  '                  = 13                               'TV out                            
  '                  = 14                               'TV out      
  laser_good_pin     = 18                                'high if laser triggers are detected
  motor_Looked_pin   = 19                               'high out if motor looked to video signal                
  servo_c_pin        = 20                               'servo C out
  servo_m_pin        = 21                               'servo M out 
  servo_y_pin        = 22                               'servo Y out             
  mcp3204_CSSHDN_pin = 23                               'comunication to joystick 
  servo_k_pin        = 24                               'servo K out                                                                                        
  mcp3204_clock_pin  = 25                                
  mcp3204_DigOut_pin = 26                                
  mcp3204_DigIn_pin  = 27 
         
  PotMax             = 1000                             'The maximum power to the motor OUT OF 4095
  PotMin             = 40                               'The minimum power to the motor OUT OF 4095

VAR          
  {RAM assignment for cogs}
  long Stack0[128]                                      'this RAM will be assigned to COG         1320 byte / 4 = 330 long
  long Stack1[50]                                       'this RAM will be assigned to COG1        155 byte / 4 = 39 long 
  long Stack2[50]                                       'this RAM will be assigned to COG2     
  long Stack3[33]                                       'this RAM will be assigned to COG2        107 / 4 = 27          126/4=32

  byte cog_motorPWM_COGID
  byte cog_video_COGID 
  byte cog_loopback_COGID

  long elapsed_time_holder
                    
  long elapsed_time          
  long elapsed_time2                                                               
  long array[10]
  long arrayused
  long newnumber                                                            
  byte novideo
  long motorspeed                                        
  long TimeLow
  long TimeHigh
  long kill         
  byte write_start_time                                 '8 bits; 0 to 255
  byte write_end_time                                   '8 bits; 0 to 255                 0 = low, 1 = high
  byte video_pin_last_state                             'registors the video pin state last time the loop whent by
'  long frameDurationInMs                                                           
                                                        
  byte PAL_or_NTSC_value                                '0=no signal, 1=PAL, 2=NTSC
  byte byte_speed
  long video
  long offby                                            'value on how much the feedback loop is off by
  long ramp_up_pause                                    '0 = off   -1 = on
  long up_to_speed                                      '0 = off   -1 = on
  
  'for motor
  
  long testfreq, testpercent
  byte idx
   {{ 
                 
  long PulseWidth
  long Cycle_time
  long period

            
  long PulsWidth         'The assembly program will read this variable from
                         'the main Hub RAM to determine the
                         'servo signal's high pulse duration
  long stack [50]        'space for Cog managing the motor pulses
  long stack2[50]        'space for Cog two
  long pcount            'potentiometer reading.
  byte arrow             'motor direction arrow

  }}
  
OBJ                                                     'methods we use                                                                                     
  
 ' UTIL  : "Utilities"                              'for general methods
   
  PWM   : "PWM_2ctrx"
  text  : "tv_text"
   
PUB Go | index, i                                       'main cog / Local variables                                                 

  cognew (cog_video, @Stack1)                           'create COG_video                 
  cognew (cog_loopback, @Stack2)                        'create COG_video     
  cognew (cog_motorPWM, @Stack3)                        'create COG_video

  text.start(12) 
                                                                                    
' dira[motor_pin]~~                                     'set direction for amplifier
' outa[motor_pin]:=%000
                                   
  'cognew(MoveMotor(motor_pin),@Stack)                  'start a new cog and run MoveMotor method on it, output pulses on P8
                                                        'The new cog that is started above continuously reads the "position" variable as it's changed 
                                                        'by the example Spin code below


  'cognew(cog_two, @stack2)                             'start new cog for the LCD    
                                                                       
  set_pin_to_input(video_pin)                           'assign pin input
  set_pin_to_input(loopback_pin)                        'assign pin input
  set_pin_to_input(laser_pin)                           'assign pin input
  set_pin_to_input(missing_pin)                         'assign pin input
  set_pin_to_input(play_FW_pin)                         'assign pin input
  set_pin_to_input(play_RW_pin)                         'assign pin input
  set_pin_to_input(halfspeed_pin)                       'assign pin input
  set_pin_to_input(feeding_speed_pin)                   'assign pin input
                                                                           
' set_pin_to_output(IsMissing_pin)                      'assign pin output
  set_pin_to_output(pal_pin)                            'assign pin output
  set_pin_to_output(ntsc_pin)                           'assign pin output
' set_pin_to_output(servo_c_pin)                        'assign pin output
' set_pin_to_output(servo_m_pin)                        'assign pin output
' set_pin_to_output(servo_y_pin)                        'assign pin output
' set_pin_to_output(servo_k_pin)                        'assign pin output
                                                                                  
' LEDs on QuickStart 16-23
' set_pin_to_output(20)   
' set_pin_to_output(21)     

                                                        '$A,16    center add empty spaces (16 spaces)  
                                                        '$B,12    goto line count from top (12 count)     
                                                        '$C,1,    sets background color
                                                        '$C,2,    gray
                                                        'sC,3
                                                        '$C,4,
                                                        '$C,5,    green
                                                        '$C,6,    pink
                                                        '13,      next line
                                                                         
  testpercent:=50
   
  repeat

  
    text.str(string($A,1,$B,1,$C,7,"speed:",$C,8)) 
    if ina[feeding_speed_pin]==high
      text.str(string($A,7,$B,1,$C,3," feeding ",$C,8)) 
    else              
      text.str(string($A,7,$B,1,$C,7," regular ",$C,8))
                              
    text.str(string($A,1,$B,2,$C,7,"speed:",$C,8))
    if ina[halfspeed_pin]==high              
      text.str(string($A,7,$B,2,$C,3," 1/2 "))
    else                                     
      text.str(string($A,7,$B,2,$C,7," 1:1 ")) 
       
    if ina[play_FW_pin]==high              
      text.str(string($A,20,$B,1,$C,3," Play "))                              'set motor direction/run
    if ina[play_RW_pin]==high                                       
      text.str(string($A,20,$B,1,$C,3," Back "))             


    if ina[play_RW_pin]==high or ina[play_FW_pin]==high                        'set motor speed
      if ina[feeding_speed_pin]==high
        motorspeed := 100      
        'motorspeed := 0 
      elseif ina[halfspeed_pin]==high
        motorspeed := 512      
        'motorspeed := 0    
      else
        motorspeed := 1_024
        'motorspeed := 1_000  
    else   
      text.str(string($A,20,$B,1,$C,7,"<< >> "))
      motorspeed := 0
                         
    if PAL_or_NTSC_value==0                                                     'no video signal
      turnOff_LED(pal_pin)
      turnOff_LED(ntsc_pin)                           
      text.str(string($A,28,$B,1,$C,6," No Video  ",$C,7))
    elseif PAL_or_NTSC_value==1                                                 'is PAL
      turnOn_LED(pal_pin)
      turnOff_LED(ntsc_pin)                           
      text.str(string($A,28,$B,1,$C,8," PAL Video "))
    else                                                                        'is NTSC
      turnOn_LED(ntsc_pin)
      turnOff_LED(pal_pin)                                                                                     
      text.str(string($A,28,$B,1,$C,8,"NTSC Video "))
      
    if true 'ifnot PAL_or_NTSC_value==1

      elapsed_time_holder := elapsed_time   
      newnumber:=1
      REPEAT arrayused From 1 to 9
        if array[arrayused]==elapsed_time_holder
          newnumber:=0
      if newnumber==1         
        REPEAT arrayused From 1 to 9
          if array[arrayused]==0 and newnumber==1
            array[arrayused]:=elapsed_time_holder
            newnumber:=0
                            
        text.str(string($A,28,$B,4))
        text.dec(array[1])
        text.str(string($A,28,$B,5))
        text.dec(array[2])
        text.str(string($A,28,$B,6))
        text.dec(array[3])
        text.str(string($A,28,$B,7))
        text.dec(array[4])
        text.str(string($A,28,$B,8))
        text.dec(array[5])  
        text.str(string($A,28,$B,9))
        text.dec(array[6])
        text.str(string($A,28,$B,10))
        text.dec(array[7]) 
        text.str(string($A,28,$B,11))
        text.dec(array[8])  
                                       
    text.str(string($A,1,$B,3,"COGID: "))   
    text.dec(COGID)  
    text.str(string(","))         
    text.dec(cog_video_COGID)  
    text.str(string(","))                             
    text.dec(cog_loopback_COGID)   
    text.str(string(","))                             
    text.dec(cog_motorPWM_COGID) 
      
    text.str(string($A,1,$B,4,"elapsed_time:            "))
    text.str(string($A,1,$B,4,"elapsed_time:  ")) 
    text.dec(elapsed_time)                                     
    text.str(string($A,1,$B,5,"elapsed_time2:           "))
    text.str(string($A,1,$B,5,"elapsed_time2: "))
    text.dec(elapsed_time2)   

    text.str(string($A,1,$B,7,"stop_time2:              "))
    text.str(string($A,1,$B,7,"stop_time2:  "))
    'text.dec(stop_time2)                                       
    text.str(string($A,1,$B,8,"start_time2:             "))    
    text.str(string($A,1,$B,8,"start_time2: "))
    'text.dec(start_time2)     
                                                      
    text.str(string($A,1,$B,12,$C,1,"1"))           
    text.str(string($A,2,$B,12,$C,2,"2"))            
    text.str(string($A,3,$B,12,$C,3,"3"))            
    text.str(string($A,4,$B,12,$C,4,"4"))              
    text.str(string($A,5,$B,12,$C,5,"5"))             
    text.str(string($A,6,$B,12,$C,6,"6"))             
    text.str(string($A,7,$B,12,$C,7,"7"))             
    text.str(string($A,8,$B,12,$C,8,"8"))     
    text.str(string($A,14,$B,12,$C,7," cnt: ",$C,7))  
    text.dec(cnt)     
    text.str(string("    "))

    {{       
    case motorspeed
      0:
        byte_speed:=0
      100:             
        if elapsed_time2 < 10 * elapsed_time + 2_500
          byte_speed:=0
        else
          byte_speed:=1
      500:
        if elapsed_time2 < 2 * elapsed_time + 2_500
          byte_speed:=0
        else
          byte_speed:=1
      1_000:        
        if elapsed_time2 < elapsed_time + 2_500
          byte_speed:=0
        else
          byte_speed:=1

      }}
          
                                                   'show if motor is up to speed   PRI tospeed
    if byte_speed == 1
      text.str(string($A,20,$B,2,$C,5," motor in sync ",$C,7))
    else        
      text.str(string($A,20,$B,2,"                 "))
                                    
PUB cog_motorPWM
                
  cog_motorPWM_COGID := COGID
  
  repeat
    'testfreq :=  1000  ' or use 1Hz for demo on LEDs
    'repeat idx from 1 to 3 ' 1kHz, 2kHz, 3kHz
      'repeat testpercent from 2 to 98
        'PWM.PWMctrx2(6,testfreq*idx, testpercent)
        'waitcnt(clkfreq/10 + cnt)
        
    'waitcnt(clkfreq/1_000 + cnt)
                                     
    PWM.PWMctrx2(motor_pin,motorspeed,testpercent)
                
PUB cog_video | tmp, start_time, stop_time  

  {{
  detects video type (NTSC, PAL, or missing) signal input
  will return
      
          PAL_or_NTSC_value 0 for missing signal 
          PAL_or_NTSC_value 1 for PAL
          PAL_or_NTSC_value 2 for NTSC   
  }}                                                              
  
  cog_video_COGID := COGID
                                                                          
  repeat             
    tmp:=cnt                                              'assign temporary time stamp
                                                          'to break out of repeat loop if not video signal is present                                                 
    repeat while ina[video_pin]==0                        'hold at low
      if 6_000_000<(||(cnt-tmp))    
        quit                                              'brake out of repeat loop
    start_time:=cnt                                       'time stamp on just went high
    tmp:=cnt                                              'reassign temporary time stamp
                                                          'to break out of repeat loop if not video signal is present                                                                                           
    repeat while ina[video_pin]==1                        'hold at high                              
      if 6_000_000<(||(cnt-tmp))                   
        quit                                              'brake out of repeat loop
    tmp:=cnt                                              'reassign temporary time stamp
                                                          'to break out of repeat loop if not video signal is present  
    repeat while ina[video_pin]==0                        'hold at low
      if 6_000_000<(||(cnt-tmp))         
        quit                                              'brake out of repeat loop  
    stop_time:=cnt                                        'time stamp on just went high again
    
    if stop_time>start_time                               'read timer differance   
      elapsed_time:=stop_time - start_time
    else
      elapsed_time:=(POSX - start_time)+(POSX + stop_time)               
                                                                                                                                                         
    if elapsed_time>3_300_000                                  
      PAL_or_NTSC_value:=0                                'no video signal   
    elseif elapsed_time>2_700_000                          
      PAL_or_NTSC_value:=1                                'is PAL    
    else                                                       
      PAL_or_NTSC_value:=2                                'is NTSC    

PUB cog_loopback | tmp2, start_time2, stop_time2, noloopback

  {{
     find out time between end of loopback trigger and start of video tirgger
     this is to lock the motor to the video signal at exact location
  }}                                                              

    
  cog_loopback_COGID := COGID
                                                                         
  repeat          
    noloopback:=1                   
    tmp2:=cnt                                             'assign temporary time stamp
                                                                                                                                                                                               
    repeat while ina[loopback_pin]==1                     'hold at low (low duration is short)
      if 20_000_000<(||(cnt-tmp2))   
        noloopback:=0
        quit                                              'brake out of repeat loop
   
    repeat while ina[loopback_pin]==0                     'hold at low (low duration is short)
      if 20_000_000<(||(cnt-tmp2))
        noloopback:=0                                     'to break out of repeat loop if no loopback signal is present
        quit                                              'brake out of repeat loop
        
    start_time2:=cnt                                      'time stamp on just went high
    tmp2:=cnt                                             'reassign temporary time stamp
                              
    repeat while ina[video_pin]==0                        'hold at low
    if PAL_or_NTSC_value==0                         
      noloopback:=0
      stop_time2:=start_time2
      quit                                                'brake out of repeat loop
    else
      stop_time2:=cnt                                     'timestap as soon it goes high
                                                                                                                                                                                                                                      
    if noloopback==1                                                                           
      elapsed_time2:=stop_time2 - start_time2
    else
      elapsed_time2:=0                                         
                      
PUB check_for_motor_go

  if play_FW_pin==high or play_RW_pin==high             'if run motor
    if up_to_speed==0
      turnOn_LED(21)
      'pause(2000)                                      'pause for 2 sec. for ramp up
      up_to_speed:=-1
    else
      turnOff_LED(21)
  elseif up_to_speed==-1
    turnOn_LED(21)
    'pause(2000)                                        'pause for 2 sec. for ramp down
    up_to_speed:=0
  else
    turnOff_LED(21)                

PUB set_pin_to_output(pin)                              'set pin to output
  dira[pin]~~                   
  outa[pin]~~                   
   
PUB set_pin_to_input(pin)                               'set pin to input
  dira[pin]~                    
  outa[pin]~
  
PUB pause(ms) | t
  t := cnt - 1088                                        'overhead compensation for call
  repeat ms
    waitcnt(t += MS_001)
  
PUB turnOn_LED(pin)
  outa[pin]:=inv_high
  
PUB turnOff_LED(pin)
  outa[pin]:=inv_low